From d88480fc48d9599a8d46e255e13ed9dbb89defde Mon Sep 17 00:00:00 2001
From: akallabeth <akallabeth@posteo.net>
Date: Sat, 27 Feb 2021 17:37:35 +0100
Subject: [PATCH 04/36] Fixed a leak on mouse cursor updates

---
 client/X11/xf_graphics.c | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

diff --git a/client/X11/xf_graphics.c b/client/X11/xf_graphics.c
index 20d54f50c..54a4b9cc7 100644
--- a/client/X11/xf_graphics.c
+++ b/client/X11/xf_graphics.c
@@ -305,14 +305,14 @@ static BOOL _xf_Pointer_GetCursorForCurrentScale(rdpContext* context, const rdpP
 		ci.yhot = pointer->yPos * yscale;
 		size = ci.height * ci.width * GetBytesPerPixel(CursorFormat);
 
-		if (!(ci.pixels = (XcursorPixel*)_aligned_malloc(size, 16)))
-		{
-			xf_unlock_x11(xfc);
-			return FALSE;
-		}
-
 		if (xscale != 1 || yscale != 1)
 		{
+			if (!(ci.pixels = (XcursorPixel*)_aligned_malloc(size, 16)))
+			{
+				xf_unlock_x11(xfc);
+				return FALSE;
+			}
+
 			if (!freerdp_image_scale((BYTE*)ci.pixels, CursorFormat, 0, 0, 0, ci.width, ci.height,
 			                         (BYTE*)xpointer->cursorPixels, CursorFormat, 0, 0, 0,
 			                         pointer->width, pointer->height))
-- 
2.30.2

